
%%                                                 DEFAULT INPUT VARIABLES
%                                                            for STAGrprof


function [IN,PLOT,SWITCH,STYLE,SAVE] = f_defaultsRprof
if ~exist('STAGrprof','file'); display(' '); display('Add the StagLab folder (and subfolders) to the MatLab search path!'); display(' '); display(' Go to: HOME >> Set Path >> Add with Subfolders'); display(' '); end

%% DEBUGGING
SWITCH.me               =   logical(0);                 %switch for extended display output

%% INPUT FILE(S)               
IN.fname_vector         =   {'test'  'test'  };         %filename
IN.number_vector        =   [   0    1 ];
IN.parameter_vector     =   [  	11    11 ];             %see f_dimParameter.m for more details
IN.folder_vector        =   {'/work/stagyy/'};

%% DIMENSIONALISATION
SWITCH.dim              =   logical(0);
SWITCH.parameterSuite   =   'standard';

%% SAVING
SAVE.Plot               =   logical(0);     SAVE.jpg =logical(0); SAVE.eps=logical(0); SAVE.pdf=logical(0); SAVE.png=logical(1);	% saves plot directly to directory
IN.save_string          =   '+rprof';

%% STYLING
SWITCH.stylePlots       =   logical(1);
SWITCH.styleBackground 	=   logical(1);
SWITCH.styleLegend      =   logical(1);
%font
STYLE.AllFontName     	=   'Open Sans';                %e.g. 'Helvetica','Corbel','Eurostyle','ETH Light','Open Sans'
STYLE.keyFontSize     	=   10;
%colours
STYLE.colorMode         =   'white';                    %black or white figure background
STYLE.keyColor         	=   [0.7 0.7 0.7];              %key colour used for text and axes
%lines
IN.LineWidth_plot       =   1;

%% AXES DETAILS
IN.constant_axis        =   logical(0);
IN.reverseYaxis         =   logical(1);

%% LABELLING
%PLOT.titleString        =   {'free-slip surface' 'free surface'}; %manual title if uncommented
SWITCH.title            =   logical(0);
SWITCH.annotation       =   logical(1);     STYLE.annotationLocation = 'topOutTop'; %e.g., 'topOutTop','topOutCorner','topLeft','botLeft','topRight','botRight'
PLOT.annotation         =   {'a' 'b' 'c' 'd' 'e' 'f' 'g' 'h' 'i' 'j' 'k' 'l' 'm' 'n' 'o' 'p'};  %subplot annotation strings
PLOT.annIfMoreThanOne   =   logical(1);     %add annotation only if more than 1 subplot

%% PLOT ADDITIONS
SWITCH.d_eta            =   logical(0);  %displays viscosity increase with depth
PLOT.parameter_range 	=   logical(1);  %plotting mean, min & max
    PLOT.rangeAsArea 	=   logical(1);
IN.show_legend          =   logical(0);
    PLOT.LegendLocation	=   'SouthEast';

%% PARAMETER(S) TO PLOT
IN.plotTemperature    	=   logical(1);         IN.T_logx       = 0;  %*
IN.plotViscosity      	=   logical(1);         IN.eta_logx     = 1;  %*
IN.plotStress           =   logical(1);         IN.str_logx     = 0;  %*
IN.plotStrainrate    	=   logical(0);         IN.edot_logx    = 1;  %*
IN.plotVelocity         =   logical(0);         IN.v_logx       = 0;
IN.plotVerticalVelocity =   logical(0);     	IN.vz_logx      = 0;
IN.plotHorizontalVelocity=  logical(1);         IN.vh_logx      = 0;  %*

IN.plotHorizVorticity  	=   logical(0);         IN.w_logx       = 0;
IN.plotVertVorticity  	=   logical(0);         IN.w_logx       = 0;
IN.plotDivergence     	=   logical(0);         IN.div_logx 	= 0;

IN.plotDensity          =   logical(0);         IN.rho_logx     = 0;

IN.plotAdvection        =   logical(0);         IN.Hadv_logx    = 0;
IN.plotDiffusion        =   logical(0);         IN.Hdiff_logx   = 0;
IN.plotRh               =   logical(0);         IN.Rh_logx      = 0;  %*
IN.plotViscDissipation  =   logical(0);         IN.vd_logx      = 0;  %*
IN.plotAdiabaticHeating =   logical(0);         IN.ah_logx      = 0;  %*

IN.plotHeatflux         =   logical(0);         IN.HF_logx      = 0;  %*

IN.plotCrust            =   logical(0);         IN.c_logx       = 0;
IN.plotAir              =   logical(0);         %log x-axis is switched on with IN.c_logx
IN.plotContCrust     	=   logical(0);         % "
IN.plotPrimordial      	=   logical(0);         % "
IN.plotFluid          	=   logical(0);         % "
IN.plotMetal          	=   logical(0);         % "

IN.plates_analyse       =   logical(0);         IN.z_level  = 0.01; %0.01 (surface); ~0.15 (slabs)

IN.plotToroidal         =   logical(0);         IN.To_logx      = 0;  %*
IN.plotToroidalRMS      =   logical(0);         IN.To_logx      = 0;
IN.plotPoloidal         =   logical(0);         IN.Po_logx      = 0;  %*
IN.plotPoloidalRMS      =   logical(0);         IN.Po_logx      = 0;
IN.plotMobility         =   logical(0);         IN.M_logx       = 0;
IN.plotf80              =   logical(0);         IN.f80_logx     = 0;
IN.plotf90              =   logical(0);         IN.f90_logx     = 0;

%% COLOUR SET FOR MULTIPLE LINES
PLOT.ColorVector        =   [0.4 0.4 0.4
                            0.8 0.4 0.0
                            0.8 0.0 0.0
                            1.0 1.0 0.0
                            0.0 1.0 1.0
                            1.0 0.0 1.0
                            0.0 0.0 0.0
                            0.0 0.0 0.0
                            0.0 0.0 0.0
                            0.0 0.0 0.0];

%% DEFINE Y-PARAMETER
IN.plotParameterY    	=   1;
                        
end


    
    
    
    
    
    
    
    