
%%                                                    CREATE AN EMPTY PLOT

%                                                Fabio Crameri, 27.11.2015
function [PLOT,SAVE] = f_emptyPlot(SWITCH,PLOT,GRID,FIELD,STYLE,SAVE)

%% VARIABLE DEFINITIONS
minX            = min(GRID.X_3Dp(:));
minZ            = min(GRID.Z_3Dp(:));
maxX            = max(GRID.X_3Dp(:));
maxZ            = max(GRID.Z_3Dp(:));
dZ              = maxZ-minZ;
crossThick      = dZ *1/5;

%% DESIGN INPUT
crossColor   	= [0.9 0.9 0.9];
if strcmp(STYLE.colorMode,'black')
    crossColor = 1-crossColor;
end

%% COUNT SUBPLOTS
PLOT.nr_subplot = PLOT.nr_subplot+1;
nr_subplot = PLOT.nr_subplot;

%% SETUP SUBPLOT PLOT
% figure...
figure(1)
% subplot...
if isfield(PLOT,'subplotLayout') %manual arrangement
    sub_current=[PLOT.subplotLayout(1,1),PLOT.subplotLayout(1,2),nr_subplot];
else
    if PLOT.nrPlots>=4
        if mod(PLOT.nrPlots,2)
            sub_current=[(PLOT.nrPlots+1)/2 2 nr_subplot];
        else
            sub_current=[PLOT.nrPlots/2 2 nr_subplot];
        end
    else
        sub_current=[PLOT.nrPlots 1 nr_subplot];
    end
end
if PLOT.reverseLayout %top-down plotting
    if ~isfield(PLOT,'layoutNum')
        PLOT.layoutNum = zeros(sub_current(1,1),sub_current(1,2));
        idx = 0;
        for ii=1:size(PLOT.layoutNum,1)
            for jj=1:size(PLOT.layoutNum,2)
                idx = idx+1;
                PLOT.layoutNum(ii,jj) = idx;
            end
        end
        idx = 0; PLOT.layoutNumTransposed = PLOT.layoutNum;
        for jj=1:size(PLOT.layoutNum,2)
            for ii=1:size(PLOT.layoutNum,1)
                idx = idx+1;
                PLOT.layoutNumTransposed(ii,jj) = idx; %transposed layout
            end
        end
    end
    %UPDATE TO NEW LAYOUT
    %       while PLOT.nr_subplot is still setup the old way!
    nr_subplot = PLOT.layoutNum(PLOT.layoutNumTransposed==nr_subplot);
    sub_current(1,3) = nr_subplot;
end
% SUBPLOT
subplot(sub_current(1,1),sub_current(1,2),sub_current(1,3));
% CURRENT AXIS
AXcurrent = gca; %save current axes handle

%% COLORBAR
colorbar;   %define dummy colorbar
cb = NaN; 	%this is a flag if no colorbar is used

%% DRAW CROSS PATCH
xleft   = minX; % + dX/4;
xright  = maxX; % - dX/4;
% dX2     = xright-xleft;
% mid     = minZ+dZ/2;
%     patch([xleft, xleft+plateThick, xleft+dX2/2, xright-plateThick, xright, xright-dX2/2+plateThick/2, xright, xright-plateThick, xleft+dX2/2, xleft+plateThick, xleft, xleft+dX2/2-plateThick/2],...
%           [minZ,  minZ,             mid-plateThick/2,     minZ,            minZ,     mid,                maxZ,   maxZ,              mid+plateThick/2,     maxZ,            maxZ, mid],...
%         plateColor,'FaceAlpha',0.1,'EdgeColor','none')

patch([xleft, xleft+crossThick, xright, xright-crossThick],...
    [maxZ,  maxZ,             minZ,            minZ],...
    crossColor,'FaceAlpha',1.0,'EdgeColor','none')
patch([xleft, xleft+crossThick, xright, xright-crossThick],...
    [minZ,  minZ,             maxZ,            maxZ],...
    crossColor,'FaceAlpha',1.0,'EdgeColor','none')

%% ANNOTATIONS
%title
title([FIELD.name,' not available'])

%adjust axis
axis([minX maxX minZ maxZ]) %fix axis
axis off

%% SIMPLIFY FIGURE ==================================
if SWITCH.simplify
    %SET AXES ASPECT RATIO ----
    XaxisAR = GRID.aspectRatio(1);
    YaxisAR = 1;
    ZaxisAR = 1;
    set(gca,'PlotBoxAspectRatio',[XaxisAR YaxisAR ZaxisAR])
    %--------------------------
    
    %GATHER INFORMATION ABOUT SUBPLOT LAYOUT
    PLOT.spcurrent          = sub_current;
    PLOT.sp_chax            = AXcurrent;
    if exist('haxZ','var'); PLOT.sp_chaxz = haxZ; else PLOT.sp_chaxz = NaN; end
    PLOT.sp_ccb             = cb;   %colorbar handle
    PLOT.title              = 'empty plate sketch';  	%title string
    
    [PLOT] = f_splayout(SWITCH,PLOT,GRID,FIELD);
end

%% FUNCTION OUTPUT
if isfield(PLOT,'hax'); nr_hax = size(PLOT.hax,1)+1; else nr_hax = 1; end
PLOT.hax(nr_hax,1)  = AXcurrent;
SAVE.PlotHandles    = [SAVE.PlotHandles; AXcurrent];



