
%%     FILE FINDER for binary StagYY data

% Fabio Crameri, 30.07.2014

% input:
%  FILE.name
%  FILE.number
%  FILE.stem

% requires folder structure:
%  /folder/+op/...

function [FILE] = f_filefinder(FILE)
    %% CHECK FOR INPUT FILE
    %check for current file
    num_string = num2str(10000+FILE.number);
    num_string(1)='0';
    filetofind 	= [FILE.stem,FILE.name,'/',FILE.name,'_t',num_string];
    %already check for next file
    num_string2 = num2str(10000+FILE.number+1);
    num_string2(1)='0';
    nextfiletofind 	= [FILE.stem,FILE.name,'/',FILE.name,'_t',num_string2];
    
    %% CONVERT FOR WINDOWS PC
    if ispc
       filetofind       = strrep(filetofind,'/','\');
       nextfiletofind   = strrep(filetofind,'/','\');
    end
    
    %% IF FILE NOT FOUND CHECK FOR LATEST FILE
    FILE.LastFile = false;
    if ~exist(filetofind,'file')
        % check for last output file number
        for io=0:FILE.number
            if io<10000
                num_string = num2str(10000+io);
                num_string(1)='0';
            else
                num_string = num2str(10000+io);
            end
            filetofind 	= [FILE.stem,FILE.name,'/',FILE.name,'_t',num_string];
            if ispc
                filetofind       = strrep(filetofind,'/','\');
            end
            if ~exist(filetofind,'file')
                FILE.number=io-1;
                break  %exit loop
            end
        end
        FILE.LastFile = true; %last file that exist reached
    elseif ~exist(nextfiletofind,'file')
        FILE.LastFile = true; %last file that exist reached
    end
    
    %% ERROR MESSAGE IF NO FILE AT ALL IS NOT FOUND
    if FILE.number==-1
        error(['file not found - check file directory: ',filetofind])
    end
    
    %% DISPLAY INFO
    display(['Name:              ',FILE.name])
    display(['Number:            ',num2str(FILE.number)])
    
    %% ADDITIONAL OUTPUT
    FILE.directory	= strcat(FILE.stem,FILE.name,'/');
    if ispc
       FILE.directory       = strrep(FILE.directory,'/','\');
    end
end