
%% SUBPLOT LAYOUT 2.0

% Fabio Crameri, 29.07.2014

%% ABOUT
% subplots are arranged at the right hand side of the big plot and have
% indices >= 100

function [PLOT] = f_splayout(SWITCH,PLOT,GRID,FIELD)

%% account for small zoom subplots
if PLOT.zoom; nzoom=1; else nzoom=0; end
    
%% initialize fields
if PLOT.spcurrent(1,3)==1;
    PLOT.spindex = zeros(PLOT.spcurrent(1,1),PLOT.spcurrent(1,2)*(nzoom+1)); %account for small zoom subplots
    idx = 0;
    for iy=1:size(PLOT.spindex,1) %up down
        for ix=1:(nzoom+1):size(PLOT.spindex,2) %left right - skip zoom plots
            idx = idx+1;
            PLOT.spindex(iy,ix) = idx; %for numbers  BIG PLOT
            PLOT.spfname{iy,ix} = ' '; %for strings
            if nzoom==1
                PLOT.spindex(iy,ix+1) = idx+100; %for numbers ZOOM PLOT
                PLOT.spfname{iy,ix+1} = ' '; %for strings
            end
        end
    end
    %numbers
    PLOT.spfnumber  = zeros(size(PLOT.spindex,1),size(PLOT.spindex,2))*NaN;
    PLOT.spzoom     = zeros(size(PLOT.spfnumber)); %should not contain NaN
    PLOT.sp_hax     = PLOT.spfnumber;
    PLOT.sp_cb      = PLOT.spfnumber;
    %strings
    PLOT.spfieldname= PLOT.spfname;
    PLOT.sp_title   = PLOT.spfname;
end

%% NOTE big subplot
%numbers
PLOT.spfnumber(PLOT.spindex==PLOT.spcurrent(1,3))   = PLOT.number;          %filenumber
PLOT.spzoom(PLOT.spindex==PLOT.spcurrent(1,3))      = 0;                    %zoom subplot flag
PLOT.sp_hax(PLOT.spindex==PLOT.spcurrent(1,3))      = PLOT.sp_chax;         %subplot axis handle
PLOT.sp_cb(PLOT.spindex==PLOT.spcurrent(1,3))       = PLOT.sp_ccb;          %colorbar handle
%strings
PLOT.spfname{PLOT.spindex==PLOT.spcurrent(1,3)}     = {PLOT.fname};         %filename
PLOT.spfieldname{PLOT.spindex==PLOT.spcurrent(1,3)}	= {FIELD.name};         %fieldname
PLOT.sp_title{PLOT.spindex==PLOT.spcurrent(1,3)}	= PLOT.title;           %title

%% NOTE zoom subplot
if nzoom==1 
    %numbers
    PLOT.spfnumber(PLOT.spindex==PLOT.spcurrent(1,3)+100)	= PLOT.number; 	%filenumber
    PLOT.spzoom(PLOT.spindex==PLOT.spcurrent(1,3)+100)      = 1;           	%zoom subplot flag
    PLOT.sp_hax(PLOT.spindex==PLOT.spcurrent(1,3)+100)      = PLOT.sp_chaxz;%subplot axis handle
    PLOT.sp_cb(PLOT.spindex==PLOT.spcurrent(1,3)+100)       = NaN;          %colorbar handle
    %strings
    PLOT.spfname{PLOT.spindex==PLOT.spcurrent(1,3)+100}     = {PLOT.fname};	%filename
    PLOT.spfieldname{PLOT.spindex==PLOT.spcurrent(1,3)+100}	= {FIELD.name};	%fieldname
    PLOT.sp_title{PLOT.spindex==PLOT.spcurrent(1,3)+100}	= PLOT.title;	%title
end

%% count subplots  (neglecting zoom plots)
PLOT.spNum = PLOT.spNum+1; 
end