
%%  INSERT TIME ARROWS 2.0

%  Fabio Crameri, 07.08.2015

%% NOTES
% check if it handles zoom plots correctly................

function f_timeArrows(PLOT,SWITCH,STYLE)

%% INPUT
% AR_LineWidth        = 3.5;
% ar_colorGradient    = false;

%% STANDARD INPUT
if ~isfield(STYLE,'arrowColor');            STYLE.arrowColor         	= [0.5 0.5 0.5]; end 
if ~isfield(STYLE,'arrowAlpha');            STYLE.arrowAlpha            = 0.6; end 
if ~isfield(PLOT,'arrowHorizontal');        PLOT.arrowHorizontal        = 0; end
if ~isfield(PLOT,'arrowShiftVertical');  	PLOT.arrowShiftVertical   	= 0; end

%% PROBLEM CHECKING


%% ALL AXES HANDLES
pause(0.5); %might be needed
axH_all = findobj(gcf,'type','axes');
pause(0.5); %might be needed
axH_all = flipud(axH_all);
axH_plots = axH_all;
colorbarLoc = zeros(size(axH_all));
    
%% ALL COLORBAR HANDLES
cbar_handle_M = findobj(gcf,'tag','Colorbar');
cbar_handle_M = flipud(cbar_handle_M); %turn upside down so starting from top left
for i_cb=1:size(cbar_handle_M,1)
    colorbarLoc(axH_all==cbar_handle_M(i_cb)) = 1; %find colorbar positions in axH_all
end

% %% GET ALL AXES POSITIONS
% if isfield(PLOT,'sp_pos') % if subplot location is known --------------------------
%     axPos_all = zeros(size(PLOT.sp_pos,1)*size(PLOT.sp_pos,2),4) *NaN;
%     idx = 0;
%     for j_ax=1:size(PLOT.sp_pos,1)
%         for i_ax=1:size(PLOT.sp_pos,2)
%             idx = idx+1;
%             axPos_all(idx,:) = PLOT.sp_pos(j_ax,i_ax,:);
%         end
%     end
%     axPos_all(isnan(axPos_all(:,1)),:) = []; %remove invisible topo zoom plots
% 
% else %if subplot location is unknown -------------------------
    axPos_all = zeros(size(axH_all,1),4) *NaN;
    for i_ax=1:size(axH_all,1)        
        axPos_all(i_ax,:) = f_boxPosition(axH_all(i_ax));
    end
% end

if size(colorbarLoc,1)==size(axH_plots,1) && max(colorbarLoc(:))~=0 %only if needed
    %% ALL SUBPLOT HANDLES
    axH_plots(colorbarLoc==1) = [];
end
if size(colorbarLoc,1)==size(axPos_all,1) && max(colorbarLoc(:))~=0 %only if needed
    %% ALL SUBPLOT POSITIONS
    axPos_all(colorbarLoc==1,:) = [];
end

%% SET ARROW POSITION
for i_subplots=1:size(axH_plots,1)
%     AXorig      = gca; %remember original axis
    axes(axH_plots(i_subplots,1)); %activate current subplot axis
    if strcmp(PLOT.annotation(1,i_subplots),'')
        %axes(axH_plots(i_subplots,1)); %activate current subplot axis (to have zoom plots on top)
        continue
    end
    axesPOS     = axPos_all(i_subplots,:);	% [x-pos y-pos x-dist y-dist]
    roundPrecision = 2; % #decimals
    if i_subplots~=size(axH_plots,1) %check if it is to the right
        if strcmp(SWITCH.timeDirection,'leftright') 
            idx_nextRightSP = [];
            for ii_subplots=1:size(axH_plots,1)
                if round(axesPOS(1,2),roundPrecision)==round(axPos_all(ii_subplots,2),roundPrecision) && ... %needs to be rounded (???)
                        axesPOS(1,1)<axPos_all(ii_subplots,1) 
                    if isempty(idx_nextRightSP) || axPos_all(ii_subplots,1)<axPos_all(idx_nextRightSP,1) %if nextSP more left (ie.closer to current)
                        idx_nextRightSP = ii_subplots;
                    end
                end
            end
            if isempty(idx_nextRightSP)
                axesPOS = []; %no aditional plot to the bottom
                continue
            end
            axesPOSnext = axPos_all(idx_nextRightSP,:); % [x-pos y-pos x-dist y-dist]
            
        elseif strcmp(SWITCH.timeDirection,'topbot') %or to the bottom
            idx_nextLowerSP = [];
            for ii_subplots=1:size(axH_plots,1)
                if round(axesPOS(1,1),roundPrecision)==round(axPos_all(ii_subplots,1),roundPrecision) && ... %round it too according to above
                        axesPOS(1,2)>axPos_all(ii_subplots,2) 
                    if isempty(idx_nextLowerSP) || axPos_all(ii_subplots,2)>axPos_all(idx_nextLowerSP,2) %if nextSP higher (ie.closer to current)
                        idx_nextLowerSP = ii_subplots;
                    end
                end
            end
            if isempty(idx_nextLowerSP)
                axesPOS = []; %no aditional plot to the bottom
                continue
            end
            axesPOSnext = axPos_all(idx_nextLowerSP,:); % [x-pos y-pos x-dist y-dist]
        end
    else
        continue
    end
    figPos      = get(gcf,'Position');
    
    %manual shifting
    if isfield(PLOT,'arrowShiftVertical'); shiftVertical = PLOT.arrowShiftVertical; else shiftVertical = 0; end
    if isfield(PLOT,'arrowShiftHorizontal'); shiftHorizontal = PLOT.arrowShiftHorizontal; else shiftHorizontal = 0; end
        
    %get limits
    AxPos0      = axesPOS; %axis location
    AxLim       = axis(gca); %[x1 x2 y1 y2]
    AxWidth     = diff(AxLim(1:2));
    AxHeight	= diff(AxLim(3:4));
    
    %check if 3-D plot
    if size(AxLim,2)==6 %3-D
        is3Dplot = true;
        error('arrows for 3-D plots not implemented yet!')
    else %2-D
        is3Dplot = false;
    end
    %account for reverse axes I
    if strcmp(get(gca,'XDir'),'reverse')
        dummy=AxLim(1,2); AxLim(1,2)=AxLim(1,1); AxLim(1,1)=dummy;
    end
    if strcmp(get(gca,'YDir'),'reverse')
        dummy=AxLim(1,4); AxLim(1,4)=AxLim(1,3); AxLim(1,3)=dummy;
    end
    if is3Dplot && strcmp(get(gca,'ZDir'),'reverse')
        dummy=AxLim(1,6); AxLim(1,6)=AxLim(1,5); AxLim(1,5)=dummy;
    end
    
    %calculate arrow extent
    if strcmp(SWITCH.timeDirection,'leftright')
        arrowWidth0 = axesPOSnext(1,1)-(axesPOS(1,1)+axesPOS(1,3)); %in fig values
        %convert to current graph values
        % widthfigure = widthgraph/AxWidth *AxwidthFigure
        % widthgraph = widthfigure/axwidthFigure*axWidth
        arrowWidth = arrowWidth0/axesPOS(1,3)*AxWidth; %xwidth
        arrowHeight = AxHeight; %ywidth
        
        %set arrow location
        arPosX(1,1)  = AxLim(1,2);
                    if strcmp(get(gca,'XDir'),'reverse')
                        arPosX(1,2)  = AxLim(1,2)-arrowWidth; %arrow tip
                    else
                        arPosX(1,2)  = AxLim(1,2)+arrowWidth; %arrow tip
                    end
        arPosX(1,3)  = AxLim(1,2);
        
        arPosZ(1,1)  = AxLim(1,4);
                    if strcmp(get(gca,'YDir'),'reverse')
                        arPosZ(1,2)  = AxLim(1,3)-arrowHeight/2; %arrow tip
                    else
                        arPosZ(1,2)  = AxLim(1,3)+arrowHeight/2; %arrow tip
                    end
        arPosZ(1,3)  = AxLim(1,3);
                
    elseif strcmp(SWITCH.timeDirection,'topbot')
        arrowHeight0 = axesPOS(1,2)-(axesPOSnext(1,2)+axesPOSnext(1,4)); %in fig values
        
        %convert to current graph values
        % widthfigure = widthgraph/AxWidth *AxwidthFigure
        % widthgraph = widthfigure/axwidthFigure*axWidth
        arrowWidth  = AxWidth; %xwidth
        arrowHeight = arrowHeight0/axesPOS(1,4)*AxHeight; %ywidth
        
        %set arrow location
        arPosX(1,1)  = AxLim(1,1);          arPosX(1,3)  = AxLim(1,2);
                    if strcmp(get(gca,'XDir'),'reverse')
                        arPosX(1,2)  = AxLim(1,1)-arrowWidth/2; %arrow tip
                    else
                        arPosX(1,2)  = AxLim(1,1)+arrowWidth/2; %arrow tip
                    end
        
        arPosZ(1,1)  = AxLim(1,3);          arPosZ(1,3)  = AxLim(1,3);
                    if strcmp(get(gca,'YDir'),'reverse')
                        arPosZ(1,2)  = AxLim(1,3)+arrowHeight; %arrow tip
                    else
                        arPosZ(1,2)  = AxLim(1,3)-arrowHeight; %arrow tip
                    end
    end
    
    if is3Dplot
        arPos(1,1) = AxLim(1,1); arPos(1,2)=AxLim(1,3); arPos(1,3)=AxLim(1,6);
    end
    
    %% ADD ARROW PATCH
    set(gca,'XLimMode', 'manual', 'YLimMode', 'manual'); % prevent the axes from resizing automatically ???
    
    %% ADD PATCH
    if is3Dplot
    else
        h_pch = patch([arPosX(1,1) arPosX(1,2) arPosX(1,3)], ...
            [arPosZ(1,1) arPosZ(1,2) arPosZ(1,3)],...
            STYLE.arrowColor,'EdgeColor','none',...
            'FaceAlpha',STYLE.arrowAlpha,'Clipping','off');
    end
    % Clipping ? Clipping of patch to axes limits
    % 'on' (default) | 'off'
    % Clipping of patch to the axes limits, specified as one of these values:
    %
    % 'on' ? Do not display parts of the patch that are outside the axes limits.
    % 'off' ? Display the entire patch, even if parts of it appear outside the axes limits.
    % Parts of the patch might appear outside the axes limits if you create a plot, set hold on,
    % freeze the axis scaling, and then create the patch that is larger than the original plot.
    
    
    %% SWITCH BACK TO ORIGINAL AXIS
%     axes(AXorig);  %sometimes moves original axis back on top of annotation...
end



end