    
%%                                                      PARAMETER FILE 3-D
%                                                             for STAGplot

clear; clf;
SAVE.StartNum       =   2;
SAVE.StepNum        =   1;
SAVE.EndNum         =   2;      %set big in order to continue to last file, set SAVE.StartNum==SAVE.EndNum to write only one file

for nrLoop=SAVE.StartNum:SAVE.StepNum:SAVE.EndNum
    clearvars -except nrLoop SAVE; if ~exist('f_defaults','file'); display(' '); display('Add the StagLab folder (and subfolders) to the MatLab search path!'); display(' '); display(' Go to: HOME >> Set Path >> Add with Subfolders'); display(' '); end
    [IN,PLOT,SWITCH,TOPO,STYLE,SAVE] = f_defaults(SAVE); %get default variables 
    
    %% DEBUGGING
    SWITCH.me               =   logical(0);                         %switch for extended display output

    %% INPUT FILE(S)
    IN.fname_vector         =   { 'test3d'};                        %filename; it's size controls the # of plots
    IN.number_vector        =   [   nrLoop      1 ];             	%filenumber
    IN.parameter_vector     =   [  	11          11 ];           	%flag for parameter dimensionalisation (see f_dimParameter)
    IN.folder_vector        =   {'/work/plotTest/' '/work/stagyy/'};%StagYY directory including +im and +op folders

    %% DIMENSIONALISATION
    SWITCH.dim              =   logical(0);   	%converts to dimensional output as set in f_dimParameter.m                                       % converts to dimensional data
    SWITCH.parameterSuite   =   'standard';   	%see f_dimParameter.m

    %% SUBPLOT LAYOUT
%     PLOT.subplotLayout      =   [2 2];        %manually set subplot layout; only valid if uncommented; [z x]
    PLOT.reverseLayout      =   false;          %e.g., plot 3x2 instead of 2x3
    SWITCH.timeEvolution    =   logical(0);     SWITCH.timeDirection = 'topbot'; %'topbot', 'leftright'

    %% POSITIONING
    SWITCH.figurePosition   =   'auto';         %'auto' or set manually by e.g., [47 1 1300 350]
    PLOT.shiftLeft          =   0;              %shift subplot positions closer or further away from each other
    PLOT.shiftUpward        =   0;          
    
    %% COLORBAR
    SWITCH.Colorbar         =   logical(1);     IN.constantColorbar = logical(0);  
                                                SWITCH.CB_Pos = 'right';  %'right' 'bottom'
                                                SWITCH.CB_labelPos = 'right';  %'right' 'top'  
    SWITCH.ColormapAll      =   {'auto'  'noflip'}; %e.g. jet, copper, bone, pink, gray, br, bwr, w_jet, wblr, brWbl, blWgr // flip or noflip
    SWITCH.cbarLimitIndicTop = [0]; SWITCH.cbarLimitColorTop = [0.81 0.81 0.81]; %adds specific color to top/bot
    SWITCH.cbarLimitIndicBot = [0]; SWITCH.cbarLimitColorBot = [0.81 0.81 0.81]; %indicating exceeding values (only one number sets it for all plots, otherwise specify for every subplot using [0 1 0 ...])
%     %use these to set the min/max colorbar values of each field:
%     IN.topo_min             =   -0.3;
%     IN.topo_max             =   0.3;
%     IN.T_min                =   300;
%     IN.T_max                =   1150;
%     IN.Tres_min             =   -400;
%     IN.Tres_max         	  =   4000;
%     IN.eta_min              =   1e19; 
%     IN.eta_max              =   1e28; 
%     IN.str_min              =   0;
%     IN.str_max              =   5.8;
%     IN.nstr_min             =   -800;
%     IN.nstr_max             =   800;
%     % ...and each individual plot use brackets:
%     IN.edot_max             =   [3e-20  1.05e-18];
%     IN.edot_min             =   [0      0       ];
%     IN.vel_min                =   -0.01;
%     IN.vel_max                =   0.01;
         
    %% PLOT STYLING
    SWITCH.stylePlots       =   logical(1);     %style plot
    STYLE.AllFontName     	=   'Open Sans';  	%e.g. 'Helvetica','Corbel','Eurostyle','ETH Light','Open Sans'
    STYLE.keyFontSize    	=   10;
    SWITCH.styleBackground  =   logical(1);  	%style plot background of graph supplots
    SWITCH.simplify         =   logical(1);     %simplify plot layout
    
    PLOT.Style              =   'pcolor';       %use either 'contour' or 'pcolor'
    PLOT.numContours        =   100;            %#contours in contour plots
    %axes
    SWITCH.axis_off         =   logical(0);
    SWITCH.setAxisLimit     =   logical(0);     SWITCH.axisLimit = [500 1300 -5 200; 1500 2300 -5 200; ...
                                                                500 1300 -5 200; 1600 2400 -5 200];   %zoom for big plots
    SWITCH.tickDir          =   'out';          %'in' or 'out' - tickmarks location
    %colours
    STYLE.colorMode         =   {'white'};      %'white' or 'black' background
    
    %% ANNOTATIONS
    SWITCH.annotation       =   logical(1);     STYLE.annotationLocation = 'topOutTop'; %e.g., 'topOutTop','topOutCorner','topLeft','botLeft','topRight','botRight'
    SWITCH.title            =   logical(1);     
    PLOT.titleOnlyTime      =   logical(0);     %title includes only time
%     PLOT.titleString      =   {'standard'  'thin' 'thin and shallow' '' '' '' '' '' '' '' '' ''  };	%adds manual title string if uncommented
    SWITCH.texting          =   logical(1);     %write out resolution and max values of the field
    
    %% PLOT ADDITIONS
    PLOT.zoom               =   logical(0);     PLOT.zoomPos = 'northwest';                 %adds an additional plot for a close up
    PLOT.zoomVal            =   [2500 3500 -50 500 ; 900 1900 -50 500 ; 1300 2300 -50 500]; %...with the corresponding values
    PLOT.zProfile           =   logical(0);     PLOT.x_prof = 1.01;   %PLOT.z_prof = 0.1; 	%takes profile at non-dim value of x (or z if PLOT.z_prof uncommented)

    %% 3-D CARTESIAN MODEL: ISOSURFACE  -----------------------------------
    PLOT.cameraPosition     =   [59240 35752 -37631];  	% camera position for 3-D figures; standard is top: [59240 35752 -37631]; bot: [59240 35752 +37631]
    PLOT.cameraPosBotView   =   logical(0);       	%flips view to bottom up (only for 3-D box plots)
    PLOT.camProjection      =   'orthographic';  	%camera projection: either 'perspective' or 'orthographic'
    PLOT.lighting           =   'gouraud';          %lighting options, e.g., none, flat, gouraud
    PLOT.camlight           =   'headlight';     	%camlight options, e.g., headlight, left, right
    PLOT.opacity            =   [0.3 0];         	%opacity of the isosurfaces   1: last one is opaque 0: last one is also transparent]
    PLOT.isoVal             =   [0.2 0.45 0.8];     %values of isosurfaces (ranging between 0 and 1)

    PLOT.isoVal_special     =   [];                 %plots nicely colored isosurface
    PLOT.isoColor_special   =   [1.0 0.5 0.4];      %e.g., blue: [0.5 0.6 1.0] or red: [1.0 0.5 0.4]
    PLOT.opacity_special  	=   [1];                %opacity of the special isosurface(s)
    
    %% 3-D CARTESIAN MODEL: SLICING  --------------------------------------
    PLOT.Slices             =   logical(0);     %Switch to add slices
        PLOT.slice_x     	=   [50];           %in plotting values e.g.,[0:0.01:1]
        PLOT.slice_y      	=   [50];
    	PLOT.slice_z      	=   [2850];
        PLOT.SliceOpacity  	=   0.5;

    PLOT.SliceSpecial       =   logical(0);
        PLOT.slice_xS     	=   [];             %in plotting values
        PLOT.slice_yS    	=   [];
        PLOT.slice_zS     	=   [];
    
    PLOT.slice_x_V        	=   [];             %in plotting values for Quiver
    PLOT.slice_y_V       	=   [];
    PLOT.slice_z_V       	=   [];
        
    PLOT.slice_xT       	=   [];             %in plotting values
    PLOT.slice_yT        	=   [];
    PLOT.slice_zT         	=   [0.01  1.0];    %[surf cmb]
    PLOT.opacity_plotT    	=   1.0;
    
    %% POST-PROCESSING
    PLOT.indicateTrench     =   logical(0);     PLOT.IndicationDepth = -0.0263; %[nd]
    PLOT.indicateRidge      =   logical(0);     PLOT.IndicationSize  = 20;

    %% SAVING FIGURE
    SAVE.Plot               =   logical(0);     %saves plot directly to directory
        SAVE.png            =   logical(1);     SAVE.pngResolution = '-m3.0';	 
        SAVE.overwrite      =   logical(0);
        SAVE.writeDirectory =   'auto';         %'auto': save to standard folder (.../+im/...); otherwise use e.g., '/work/stagyy/'
        
    %% SAVE DATA
    SAVE.field              =   logical(0);     SAVE.mat = logical(1); SAVE.dat = logical(0);  %saves plotted 2-D/3-D field according to f_saveField
    SAVE.subductionZoneData =   logical(0);     %saves subduction zone data: [x-trench, subduction-polarity, trench/UP-vel, LP-vel, Convergence-vel]
    TOPO.saveData           =   logical(0);     %saves topo: [x, topo, topo_smooth]
    SAVE.timeDat            =   logical(0);     %saves time [nd, seconds, years]

    %% PERFORMANCE
    SWITCH.ReduceSize       =   logical(0);   	%reduces matrix size for faster plotting
    
    %% SPECIAL PLOTTING BEHAVIOUR
    SWITCH.PlotInPlot       =   logical(0);     %for every field plots data from all files onto same plot  *not implemented for all fields yet*
    SWITCH.plotDifference   =   logical(0);     %plots difference between two fields
        
    %% FIELDS TO PLOT
    IN.plotTemperature      =   logical(1);  
    IN.plotResTemperature   =   logical(0);
    IN.plotComposition      =   logical(0);
    IN.plotAir              =   logical(0);
    IN.plotDensity          =   logical(0);
    IN.plotViscosity        =   logical(0);  IN.eta_log = logical(1);
    
    IN.plotVelocity         =   logical(0);
    IN.plotVelocityX        =   logical(0);
    IN.plotVelocityZ        =   logical(0);
    IN.plotPressure         =   logical(0);  %total pressure !NOT YET DYNAMICAL PRESSURE!
    IN.plotHeatFlux         =   logical(0);  SWITCH.plotFIELDtrue=logical(1); SWITCH.plotFIELDsmooth=logical(0); SWITCH.plot3Dfield2D=logical(0);
    IN.plotEdot             =   logical(0);  IN.edot_log=logical(0);   %strain rate
    IN.plotStress           =   logical(0);  IN.str_log=logical(0);  %logarithmic stress
    IN.plotNormalStress     =   logical(0);  %sigma_zz actually
    IN.plotGeoid            =   logical(0);  TOPO.GEOIDcmb=logical(0); TOPO.GEOIDsurf=logical(1);
    IN.plotDynTopo          =   logical(0);  TOPO.both=logical(0); TOPO.dynTOPOsmooth=logical(1); TOPO.difference='comp'; %'comp' or 'diff'
    IN.plotTopo             =   logical(0);  TOPO.ascii=logical(0); TOPO.cmb=logical(0); TOPO.surf=logical(1); SWITCH.plot3Dtopo2D=logical(0); TOPO.exagFactor = 1;

    IN.plotDefMechanism     =   logical(0);
    IN.plotPrimordial       =   logical(0);
    IN.plotToroidal         =   logical(0);
    IN.plotPoloidal         =   logical(0);
    
    %% GRAPHS TO PLOT
    IN.plotTimeGraph        =   logical(0);  %any data (that has been saved previously) versus time graph
    
    %% SPECIAL PLOTS
    SWITCH.GraphVsTimePlot  =   logical(0);	 %plots in 2-D, a selected graph (x) vs. time (y)  *only for topography, yet*
    SWITCH.plotgrid         =   logical(0);  % separate figure for grid  *only for viscosity field, yet*
    IN.plotStreamfun        =   logical(0);  PLOT.streamdata='phi'; %phi (v-potential) or psi (streamfunction)
    IN.quiver_plot          =   logical(0);  % separate figure for velocity
    
    %% FIELD PLOT ADDITIONS
    IN.streamfun_T          =   logical(0);  % add streamfunction plot to fields
    IN.streamfun_eta        =   logical(0);  IN.stream_numContours = 17;
    IN.streamfun_str        =   logical(0);  PLOT.streamColor = [0.81 0.81 0.81]; PLOT.streamColoured = 'false'; %'false','bwr','br','blgr' or any colormap (needs 'freezeColors.m')
    IN.streamfun_rho        =   logical(0);  PLOT.streamWidth = 0.2;
    IN.streamfun_v          =   logical(0);
    IN.streamfun_edot       =   logical(0);

    IN.quiver_T             =   logical(0);  % add quiver plot to fields
    IN.quiver_eta           =   logical(0);
    IN.quiver_str           =   logical(0);  IN.num_del=14; IN.scale=17;
    IN.quiver_psi           =   logical(0);  PLOT.quiverColor = [0.81 0.81 0.81];
    IN.quiver_rho           =   logical(0);  PLOT.quiverWidth = 0.25;
    IN.quiver_nstr          =   logical(0);
    IN.quiver_edot          =   logical(0);
    
    IN.defmech_T            =   logical(0); %1: diffusion creep, 2: dislocation creep, 3: plasticity, 4: visc. cutoff
    IN.defmech_eta          =   logical(0); IN.defmechContours = [2 3 4];  %1.3: 1/3, 1.1: 1/10 of weakening from dislocation creep
    IN.defmech_str          =   logical(0); PLOT.defmechColor = [0.9 0.1 0.1; 0.7 0.0 0.0; 0.9 0.1 0.1; 0.1 0.9 0.1; 0.1 0.1 0.9];
    IN.defmech_edot         =   logical(0);
    
    IN.lithoThickness_T     =   logical(0); PLOT.LTfieldContour = 'temperature';
    IN.lithoThickness_eta   =   logical(0); IN.lithoTisovalue = 1600; IN.lithozmax = 500;
    IN.lithoThickness_nstr  =   logical(0);
    
    IN.fieldContour_T       =   logical(0); PLOT.fContourField = 'temperature';
    IN.fieldContour_eta     =   logical(0); IN.fContourIsovalue = 1600;
    IN.fieldContour_nstr    =   logical(0);
    IN.fieldContour_vx      =   logical(0);
    IN.fieldContour_str     =   logical(0);
    IN.fieldContour_edot    =   logical(0);
    
    TOPO.field              =   logical(0); TOPO.line = logical(1); TOPO.area = logical(1); % add topography plot to field plots
                                TOPO.lineColor = [0.2 0.2 0.2]; TOPO.color = [0.81 0.81 0.81]; TOPO.opacity = 0.9; TOPO.lineWidth = 0.25;
                                TOPO.areaFill = 'down';   %filled area in topography plot: 'none', 'down', 'updown'
                                TOPO.water = true;  %fills negative levels in topography plot with "water", i.e., a blue area
                                SWITCH.plotTOPOtrue   = logical(0);
                                SWITCH.plotTOPOsmooth = logical(1);  
    
    % //////////////////////////////////////
    %           run main routine
    [SAVE] = STAGplot(IN,PLOT,SWITCH,TOPO,STYLE,SAVE);
    % //////////////////////////////////////

    if SAVE.LastFile; break; end %last file reached
end
display('                   FINISHED.')

