
%%                                                          PARAMETER FILE
%                                                          for STAGtimedat

clear; clf;
[IN,PLOT,SWITCH,STYLE,SAVE] = f_defaultsTimedat;
if ~exist('f_defaultsTimedat','file'); display(' '); display('Add the StagLab folder (and subfolders) to the MatLab search path!'); display(' '); display(' Go to: HOME >> Set Path >> Add with Subfolders'); display(' '); end

%% DEBUGGING
SWITCH.me               =   logical(0);                 %switch for extended display output

%% INPUT FILE(S) 
IN.fname_vector         =   { 'test' 	};          %file name
IN.parameter_vector     =   [   11           11 ];  %file parameter (see f_dimParameter for more details)
IN.folder_vector        =   {'/work/plotTest/' ...
                            '/work/plotTest/' ...
                            '/work/plotTest/' ...
                            '/work/plotTest/'};     %file directory

%% SAVING
SAVE.Plot               =   logical(0);     SAVE.jpg=logical(0); SAVE.eps=logical(0); SAVE.pdf=logical(0); SAVE.png=logical(1);	% saves plot directly to directory
IN.save_string          =   '+timePlot_';

%% DIMENSIONALISATION
SWITCH.dim              =   logical(0);
SWITCH.parameterSuite   =   'standard';                 %see f_dimParameter for more details

%% STYLING
SWITCH.styleBackground	=   logical(1);
SWITCH.stylePlots       =   logical(1);
SWITCH.styleLegend      =   logical(1);
%font
STYLE.AllFontName     	=   'Open Sans';                %e.g. 'Helvetica','Corbel','Eurostyle','ETH Light','Open Sans'
STYLE.keyFontSize      	=   10;
%colours
STYLE.colorMode         =   'white';                    %'white' or 'black' figure background
STYLE.keyColor       	=   [0.7 0.7 0.7];              %key colour used for text and axes

%% APP PERFORMANCE
IN.num_write            =   1;                          %writes out every 'num_write' time step
IN.checkFileSize        =   logical(0);                 %checks for line number automatically (in case of a problem with data format)

%% PLOT ADDITIONS & LABELLING
SWITCH.parameterRange 	=   logical(1);                 %plotting mean, min & max
SWITCH.MinMaxLegend     =   logical(0);                 %legend switch for individual (mean, min, max) lines

%% ANNOTATION
SWITCH.annotation       =   logical(1);     
STYLE.annotationLocation=   'botLeft';                  %'topOutTop','topOutCorner','topLeft','botLeft','topRight','botRight'

%% PARAMETER(S) TO PLOT
IN.plotTemperature   	=   logical(1);                
IN.plotViscosity      	=   logical(1);                
IN.plotVelocity     	=   logical(1);                
IN.plotComposition      =   logical(1);                 

IN.plotRa_eff           =   logical(1);   %only 1 value
IN.plotNu_top           =   logical(0);   %only 1 value
IN.plotNu_bot           =   logical(0);   %only 1 value
IN.plotInternalHeating  =   logical(1);   %only 1 value
IN.plotHeatfluxTop   	=   logical(0);   %only 1 value
IN.plotHeatfluxBot   	=   logical(0);   %only 1 value
IN.plotEruptionRate     =   logical(0);   %only 1 value
IN.plotEruptHeatFlux  	=   logical(0);   %only 1 value
IN.plotErupta           =   logical(0);   %only 1 value
IN.plotEntrainment    	=   logical(0);   %only 1 value
IN.plotCmass_error    	=   logical(0);   %only 1 value
IN.plotTimesteps        =   logical(0);   %only 1 value
IN.plotPerformance      =   logical(1);   %only 1 value


                        
% //////////////////////////////////////
%           run main routine
[SAVE] = STAGtimedat(IN,PLOT,SWITCH,STYLE,SAVE);
% //////////////////////////////////////




    
    
    
    
    
    
    
    